
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// dots step 5 bubbles | punkte schritt 5 blasen

//////// variables
float[] dots_x;
float[] dots_y;
float[] dots_t;
float[] dots_w;

//////// setup
void setup() {
  size( 1280, 720 );
  //fullScreen();
  dots_x = new float[0];
  dots_y = new float[0];
  dots_t = new float[0];
  dots_w = new float[0];
  for ( int d=0; d<32; d++ ) {
    genData();
  }
}

//////// draw
void draw() {
  background( 0, 0, 32 );
  for ( int d=0; d<dots_x.length; d++ ) {
    stroke( 255, dots_t[d] );
    strokeWeight( dots_w[d] );
    point( dots_x[d], dots_y[d] );
  }
  genData();                                    // add a bubble each time | jedes mal eine blase hinzufuegen
  edtData();
}

//////// interaction
void keyPressed() {
  if ( key=='a' ) {
    genData();
  }
  if ( key=='s' ) {
    setup();
  }
  print( "current frame: " + frameCount );
  print( " overall dots: " + dots_x.length );
  print( "\n" );
}

//////// functions
void genData() {
  dots_x = append( dots_x, random(0,width) );
  dots_y = append( dots_y, random(0,height) );
  dots_t = append( dots_t, random(0,255) );
  dots_w = append( dots_w, random(1,width/96) );// starting out small | klein beginnend
}
void edtData() {                                // name the fuction | name der funktion
  for ( int d=0; d<dots_x.length; d++ ) {       // looping all dots | alle punkte durcharbeiten
    dots_x[d] += random( -2, 2 );               // bubbles wobbling sideways | seitwaerts wackelnde blasen
    dots_y[d] +=                                // bubbles moving up ... | aufsteigende blasen ...
      random( -dots_w[d]/8, -dots_w[d]/16 )     // ... depending on the size | ... in abhaengigkeit von der groesse
    ;
    dots_t[d] += random( -5, 5 );               // changing the transparency | transparenz veraendern
    dots_w[d] += random( 0, .5 );               // blowing bubbles | blasen vergroessern
  }  
}
