
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// dots step 6 graphics | punkte schritt 6 grafisch

//////// variables
float[] dots_x;
float[] dots_y;
float[] dots_t;
float[] dots_w;

//////// setup
void setup() {
  size( 1280, 720 );
  //fullScreen();
  dots_x = new float[0];
  dots_y = new float[0];
  dots_t = new float[0];
  dots_w = new float[0];
  for ( int d=0; d<32; d++ ) {
    genData();
  }
}

//////// draw
void draw() {
  background( 0, 0, 32 );
  for ( int d=0; d<dots_x.length; d++ ) {
    stroke( 255, dots_t[d] );
    strokeWeight( dots_w[d] );
    point( dots_x[d], dots_y[d] );
    if ( d%2==1 ) {                             // if index is an odd number | bei ungeraden indizes
      line(                                     // line from ... | linie von ...
        dots_x[d], dots_y[d],                   // ... current dot to ... | ... aktuellen punkt zum ...
        dots_x[d-1], dots_y[d-1]                // ... previous dot | ... vorherigen punkt
      );
    }
  }
  genData();
  edtData();
}

//////// interaction
void keyPressed() {
  if ( key=='a' ) {
    genData();
  }
  if ( key=='s' ) {
    setup();
  }
  print( "current frame: " + frameCount );
  print( " overall dots: " + dots_x.length );
  print( "\n" );
}

//////// functions
void genData() {
  dots_x = append( dots_x, random(0,width) );
  dots_y = append( dots_y, random(0,height) );
  dots_t = append( dots_t, random(0,255) );
  dots_w = append( dots_w, random(1,width/24) );
}
void edtData() {
  for ( int d=0; d<dots_x.length; d++ ) {
    dots_x[d] += random( -5, 5 );
    dots_y[d] +=
      random( -dots_w[d]/8, -dots_w[d]/16 )
    ;
    dots_t[d] += random( -5, 5 );
    dots_w[d] += random( 0, .5 );
  }  
}
