
//////// DesCode
//////// richard.dank@fh-joanneum.at
//////// http://richdank.com/theory/descode/
//////// dots step 5 | punkte schritt 5

//////// variables
float[] dots_x;
float[] dots_y;
float[] dots_t;
float[] dots_w;

//////// setup
void setup() {
  size( 1280, 720 );
  //size( 1280, 720, OPENGL );                  // check hardware acceleration - if applicable | hardware beschleunigung ausprobieren - falls vorhanden
  //fullScreen();
  frameRate( 25 );                              // setting a specific framerate | bildwiederholungsrate festsetzen
  dots_x = new float[0];
  dots_y = new float[0];
  dots_t = new float[0];
  dots_w = new float[0];
  if ( false ) {
    for ( int d=0; d<8; d++ ) {
      genData( false );
    }
  }
}

//////// draw
void draw() {
  background( 255 );
  String tit = "RIC'S DOTS running at ";        // set text for the title | text fuer die titelzeile
  tit += nf(frameRate,2,1) + "fps";             // output current frames per second | aktuelles bildwiederholungsrate anhaengen
  surface.setTitle( tit );
  for ( int d=0; d<dots_x.length; d++ ) {
    stroke( 0, dots_t[d] );
    strokeWeight( dots_w[d] );
    point( dots_x[d], dots_y[d] );
    varData( d );                               // call the fuction | funktion aufrufen
  }
}

//////// interaction 
void keyPressed() {
  if ( key=='a' ) {
    genData( false );
  }
  if ( key=='s' ) {
    setup();
  }
  print( "current frame: " + frameCount );
  print( " overall dots: " + dots_x.length );
  print( "\n" );
}
void mouseDragged() {
  genData( true );
}

//////// functions
void genData( Boolean use_mouse ) {
  if ( use_mouse ) {
    int delta = width / 32;
    int x0 = mouseX - delta;
    int x1 = mouseX + delta;
    int y0 = mouseY - delta;
    int y1 = mouseY + delta;
    dots_x = append( dots_x, random(x0,x1) );
    dots_y = append( dots_y, random(y0,y1) );
  } else {
    dots_x = append( dots_x, random(0,width) );
    dots_y = append( dots_y, random(0,height) );
  }
  dots_t = append( dots_t, random(0,255) );
  dots_w = append( dots_w, random(1,width/24) );
}
void varData( int id ) {                        // name the fuction | name der funktion
  int delta = width / 640;                      // set max. displacement | max. verschiebung setzen
  dots_x[id] += random( -delta, delta );        // changing values | werte veraendern
  dots_y[id] += random( -delta, delta );        // changing values | werte veraendern
  dots_t[id] += random( -1, 1 );                // changing values | werte veraendern
  dots_w[id] += random( -delta, delta );        // changing values | werte veraendern
  dots_x[id] = constrain( dots_x[id],0,width ); // setting limits | grenzen setzen
  dots_y[id] = constrain( dots_y[id],0,height );// setting limits | grenzen setzen
  dots_t[id] = constrain( dots_t[id],0,255 );   // setting limits | grenzen setzen
  dots_w[id] = constrain( dots_w[id],1,width ); // setting limits | grenzen setzen
}
